package de.dassit.dassadmin;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class PasswordCheckTool {
	protected static String command="/usr/sbin/cracklib-check";
	
	protected String pipe(String command, String input) throws IOException, InterruptedException {
		if(input.length()>63) {
			throw new IOException("pipe buffer size exceeded");
		}

		StringBuffer buffer=new StringBuffer();
		Process proc = Runtime.getRuntime().exec(command);

		DataInputStream in = new DataInputStream(proc.getInputStream());
		DataOutputStream out = new DataOutputStream(proc.getOutputStream());
		
		PrintWriter writer = new PrintWriter(out);
		writer.print(input);
		writer.close();
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));

		String line;
		try {
			while ((line = reader.readLine()) != null) {
				buffer.append(line);
				buffer.append('\n');
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		proc.waitFor();

		return buffer.toString();
	}

	public void setCommand(String c) {
		command=c;
	}
	public String check(String username, String newPassword) throws IOException, InterruptedException {
		String result = pipe(command,newPassword);
		int i = result.lastIndexOf(':');
		if(i<=0) {
			throw new IOException("cracklib-check chat failed");
		}
		return result.substring(i+2);
	}
}
